<template>
  <single-panel
      v-if="order"
  >
    <div class="order-tracking">
      <div class="order-tracking__main">
        <div class="order-tracking__content" >
          <order-tracking-map :track-data="order.trackData"></order-tracking-map>
          <div class="order-tracking__event">
            <div class="order-tracking__event--table">
              <ob-table
                  :items="tableItems"
                  :columns="tableColumns"
                  :functionalPanel="false"
                  :tableLayoutFixed="false"
                  :footerDisabled="true"
                  data-qa="orderExecutionTable"
                  ref="obTableExecution"
              >
                <template v-slot:address="{ data }">
                  <i :class="['icon', data.item.type === 'FROM' ? 'route-loading' : 'route-unloading']"></i>
                  {{data.item.address}}
                </template>
                <template v-slot:arrival="{ data }">
                  {{ data.item.arrival.time }}
                  <p>{{ data.item.arrival.date }}</p>
                </template>
                <template v-slot:etaPlan="{ data }">
                  {{ data.item.etaPlan.time}}
                  <p>{{ data.item.etaPlan.date}}</p>
                </template>
                <template v-slot:etaCurrent="{ data }">
                  {{ data.item.etaCurrent.time}}
                  <p>{{ data.item.etaCurrent.date}}</p>
                </template>
                <template v-slot:parking="{ data }">
                  {{ data.item.parking.time}}
                  <p>{{ data.item.parking.date}}</p>
                </template>
                <template v-slot:arrivePrr="{ data }">
                  {{ data.item.arrivePrr.time}}
                  <p>{{ data.item.arrivePrr.date}}</p>
                </template>
                <template v-slot:leavePrr="{ data }">
                  {{ data.item.leavePrr.time}}
                  <p>{{ data.item.leavePrr.date}}</p>
                </template>
              </ob-table>
            </div>
          </div>
        </div>
      </div>

      <aside class="sidebar">
        <h1 class="order-number">
          Заказ {{ order.main.number}}
        </h1>
        <span class="status status--executed">
          {{ statusesMap[order.main.status] || "-" }}
        </span>

        <div class="side-info__row" v-if="!!order.main.clientTitle">
          <div class="side-info__title">Заказчик</div>
          <div class="side-info__value-outer">
            <i :class="['icon', 'role-client']"></i>
            <span class="side-info__value">
            {{ order.main.clientTitle }}
          </span>
          </div>
        </div>
        <div class="side-info__row" v-if="!!order.main.tractorNumber">
          <div class="side-info__title">Номер ТС</div>
          <div class="side-info__value-outer">
            <span class="side-info__value">
            {{ order.main.tractorNumber }}
          </span>
          </div>
        </div>
        <div class="side-info__row" v-if="!!order.main.wagonNumber">
          <div class="side-info__title">Номер прицепа</div>
          <div class="side-info__value-outer">
            <span class="side-info__value">
            {{ order.main.wagonNumber }}
          </span>
          </div>
        </div>
        <div class="side-info__row" v-if="!!order.main.externalNumber">
          <div class="side-info__title">Внешний номер заказа</div>
          <div class="side-info__value-outer">
            <span class="side-info__value">
            {{ order.main.externalNumber }}
          </span>
          </div>
        </div>
        <div class="side-info__row" v-if="!!order.main.doerTitle">
          <div class="side-info__title">Перевозчик</div>
          <div class="side-info__value-outer">
            <i :class="['icon', 'truck-sm']"></i>
            <span class="side-info__value">
            {{ order.main.doerTitle }}
          </span>
          </div>
        </div>

        <div class="side-info__row" v-if="order.main.status === 'PROCESSED'">
          <div class="side-info__info">
            Трекинг завершён
          </div>
        </div>

        <div class="side-info__row" v-if="order.main.status === 'NEW'">
          <div class="side-info__info">
            Ожидание начала трекинга
          </div>
        </div>

      </aside>
    </div>
  </single-panel>
</template>

<script>
import api from '@/api';
import singlePanel from 'common-components/src/obComponents/obSinglePanels';
import state, { setState } from "@/pages/orderPage/state/tracking";
import OrderTrackingMap from '@/components/Order/orderTracking/map';
import obTable from 'common-components/src/obComponents/obTable';

export default {
  name: "UnauthorizedTrackingMap",

  components: {
    singlePanel,
    OrderTrackingMap,
    obTable
  },

  props: [],

  data() {
    return {
    }
  },

  async created() {
    this.setStateOrder(null);
    let notificationId = new Date().getTime() + "save";
    try {
      this.$notification({
        type: "system_notification_in_load",
        message: "Загрузка",
        id: notificationId
      });

      const order = await api.orders.getUnauthorizedTrackingOrder(this.$route.params.uuid);
      if (order) {
        this.setStateOrder(order);
      }

    } catch (e) {
      this.$notification({
        type: "system_notification_error",
        message: "Не удалось загрузить"
      });
      console.error(e);
    } finally {
      this.$notification({ event: "close", id: notificationId });
    }
  },

  computed: {
    order() {
      return state.order
    },

    statusesMap() {
      return state.statusesMap;
    },

    tableColumns() {
      return [
        {
          title: "Адрес",
          key: "address",
          slotName: "address"
        },
        {
          title: "Плановое прибытие",
          key: "arrival",
          slotName: "arrival"
        },
        {
          title: "ETA Плановое",
          key: "etaPlan",
          slotName: "etaPlan"
        },
        {
          title: "ETA Текущее",
          key: "etaCurrent",
          slotName: "etaCurrent"
        },
        {
          title: "Въезд на стоянку",
          key: "parking",
          slotName: "parking"
        },
        {
          title: "Въезд в зону ПРР",
          key: "arrivePrr",
          slotName: "arrivePrr"
        },
        {
          title: "Выезд из зоны ПРР",
          key: "leavePrr",
          slotName: "leavePrr"
        }
      ]
    },

    tableItems() {
      return this.order.locations.map(item => {
        return {
          address: item.title,
          arrival: {
            time: item.arrivalSlotStartDt && item.arrivalSlotEndDt ? `${this.getTime(item.arrivalSlotStartDt)} - ${this.getTime(item.arrivalSlotEndDt)}` : '-',
            date: item.arrivalSlotStartDt ? this.getDate(item.arrivalSlotStartDt) : '-'
          },
          type: item.operationType === 'LOADING' ? 'FROM' : 'TO',
          etaPlan: {
            time: item.etaPlanDt ? this.getTime(item.etaPlanDt) : '-',
            date: item.etaPlanDt ? this.getDate(item.etaPlanDt) : '-'
          },
          etaCurrent: {
            time: item.etaCurrentDt ? this.getTime(item.etaCurrentDt) : '-',
            date: item.etaCurrentDt ? this.getDate(item.etaCurrentDt) : '-'
          },
          parking: {
            time: item.arrivedAtParkingDt ? this.getTime(item.arrivedAtParkingDt) : '-',
            date: item.arrivedAtParkingDt ? this.getDate(item.arrivedAtParkingDt) : '-'
          },
          arrivePrr: {
            time: item.arrivedAtPrrDt ? this.getTime(item.arrivedAtPrrDt) : '-',
            date: item.arrivedAtPrrDt ? this.getDate(item.arrivedAtPrrDt) : '-'
          },
          leavePrr: {
            time: item.departuredFromPrrDt ? this.getTime(item.departuredFromPrrDt) :'-',
            date: item.departuredFromPrrDt ? this.getDate(item.departuredFromPrrDt) : '-'
          }
        }
      })
    },
  },

  watch: {},

  mounted() {
  },

  methods: {
    setStateOrder(data) {
      setState(data)
    },

    getTime(date) {
      const temp = new Date(date);
      const hours = temp.getHours() + '';
      const minutes = temp.getMinutes() + '';
      return `${hours.padStart(2, 0)}:${minutes.padStart(2, 0)}`
    },

    getDate(date) {
      const temp = new Date(date);
      const year = temp.getFullYear();
      const month = temp.getMonth() + 1 + '';
      const day = temp.getDate() + '';
      return `${day.padStart(2, 0)}.${month.padStart(2, 0)}.${year}`;
    },
  },
}
</script>

<style lang="scss" scoped>
@import '~common-components/src/static/css/variables';
@import '~common-components/src/static/css/mixins';

.order-tracking {
  display: flex;
  height: 100%;
  position: relative;
}

.order-tracking__main {
  flex-grow: 1;
  overflow-y: hidden;
  display: flex;
  flex-direction: column;
}

.order-tracking__content {
  flex-grow: 1;
  position: relative;
}

.sidebar {
  position: relative;
  flex: 0 0 316px;
  z-index: 2;
  width: 316px;
  box-shadow: 0px 4px 10px rgba(0, 75, 200, 0.06), 0px 0px 12px rgba(0, 75, 200, 0.04), 0px 0px 2px rgba(0, 75, 200, 0.15);
  padding: 30px;
}

.status {
  margin-top: 4px;
  padding: 10px;
  @include font-mixin(16px, 20px, 400, $color-text-base);

  &--executed {
    background:rgba(16, 207, 150, 0.1);
  }
}

.order-number {
  @include font-mixin(24px, 36px, 700, $style-black);
  margin-bottom: 10px;
}

.side-info {
  &__row {
    margin-top: 25px;
  }
  &__title {
    margin: 2px 0;
    font-family: Roboto, sans-serif;
    font-style: normal;
    font-weight: 400;
    font-size: 10px;
    line-height: 12px;
    letter-spacing: 0.4px;
    color: $gray-slate;
    mix-blend-mode: normal;
  }
  &__value-outer {
    .icon {
      color: $color-blue-navy-blue;
    }
  }
  &__value {
    font-family: Roboto, sans-serif;
    font-style: normal;
    font-weight: 400;
    font-size: 14px;
    line-height: 16px;
    letter-spacing: 0.2px;
    vertical-align: text-top;
  }
}

.order-tracking__event {
  background: white;
  border-radius: 3px;
  position: absolute;
  left: 20px;
  right: 20px;
  bottom: 20px;
  max-height: 340px;
  overflow-y: auto;
  z-index: 100;
}

.order-tracking__event {
  &--table {
    border: 1px solid $lavender;
    border-radius: 3px;

    .icon.route-loading {
      color: $diamond-orange-yellow;
      font-size: 14px;
    }

    .icon.route-unloading {
      color: $Green-700;
      font-size: 14px;
    }
  }
}

.side-info__info {
  display: inline-flex;
  padding: 8px 10px;
  background-color: rgba($color-green-light, 0.4);
}

</style>